<template>
  <div v-if="display">
    <vciWebReferTree
      v-if="refertype=='tree'"
      :key="key" ref="vciWebReferTree"
      :data-key="key"
      :disabled="disabled"
      :referConfig="referConfig"
      :text="text"
      :title="title"
      :value="value"
      @setValue="setValue">
    </vciWebReferTree>

    <vciWebReferTable
      v-else-if="refertype=='table'"
      :key="key" :data-key="key"
      :disabled="disabled"
      :referConfig="referConfig"
      :referType="referType"
      :text="text"
      :title="title"
      :value="value"
      @setValue="setValue">
    </vciWebReferTable>

    <vciWebReferDefalut
      v-else
      :key="key"
      :data-key="key"
      :disabled="disabled"
      :referConfig="referConfig"
      :referType="referType"
      :text="text" :title="title"
      :value="value"
      @setValue="setValue">
    </vciWebReferDefalut>

  </div>
</template>

<script>
import vciWebReferTree from "./vciWebReferTree.vue";
import vciWebReferTable from "./vciWebReferTable.vue";
import vciWebReferDefalut from "./vciWebReferDefalut.vue";

export default {
  name: "vciWebRefer",
  props: ["referConfig", "value", "text", "disabled", "display", 'key', 'referType'],
  components: {vciWebReferTree, vciWebReferTable, vciWebReferDefalut},
  data() {
    return {
      reterTypeLeavl: '213',
      refertype: this.referConfig.options.type,
      emitData: {},
      title: '',
      display: this.display || true,
      disabled: this.disabled || false
    };
  },
  created() {
    if (!this.referConfig.options && this.referConfig.options.isMuti == undefined) {
      this.referConfig.options = {
        isMuti: this.referConfig.options.muti || false
      }
    }
  },
  mounted() {
    var title = this.referConfig.title || '';
    title = title.replace(":", "");
    title = title ? ('为【' + title + '】选取值') : ('为【' + this.referConfig.showField + '】选取值');
    this.title = title;
  },
  methods: {
    setValue(value) {
      this.emitData = value;
    }
  },
  watch: {
    // 修改反馈到父组件
    emitData: {
      deep: true,
      immediate: true,
      handler(newV) {
        this.text = newV.text;
        this.value = newV.value;
        this.$emit("setReferValue", newV);
      }
    },
  }
}
</script>

<style scoped>

</style>
